# Copyright (C) 2018-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

# * The software is provided "as is" without any warranty, neither express
#   nor implied.
# * In no event will the author be held liable for any damage(s) arising
#   from the use of the software.
# * Redistribution of the software is allowed only in unmodified form.
# * Permission is granted to use the software solely for personal private
#   and non-commercial purposes.
# * An individuals use of the software in his or her capacity or function
#   as an agent, (independent) contractor, employee, member or officer of
#   a business, corporation or organization (commercial or non-commercial)
#   does not qualify as personal private and non-commercial purpose.
# * Without written approval from the author the software must not be used
#   for a business, for commercial, corporate, governmental, military or
#   organizational purposes of any kind, or in a commercial, corporate,
#   governmental, military or organizational environment of any kind.

.SUFFIXES:

test: BTI_RDCL.EXE
	"$(MAKEDIR)\BTI_RDCL.EXE"

sign: BTI_RDCL.EXE
	SIGNTOOL.EXE Sign /A /D "Meltdown, Spectre and Spectre-NG Update Check Utility" /DU "https://skanthak.hier-im-netz.de/spectre.html" /N "Stefan Kanthak" /T "http://timestamp.digicert.com/" /V $**
#	SIGNTOOL.EXE Sign /AS /D "Meltdown, Spectre and Spectre-NG Update Check Utility" /DU "https://skanthak.hier-im-netz.de/spectre.html" /FD SHA256 /N "Stefan Kanthak" /TD SHA256 /TR "http://timestamp.digicert.com/" /V $**

clobber: clean
	Erase BTI_RDCL.EXE

clean:
	Erase BTI_RDCL.EXP BTI_RDCL.LIB BTI_RDCL.TMP
	Erase BTI_RDCL.DOS BTI_RDCL.OBJ BTI_RDCL.RES

BTI_RDCL.LIB: BTI_RDCL.TMP
	LINK.EXE /LIB /BREPRO /DEF /EXPORT:NtQuerySystemInformation /EXPORT:RtlNtStatusToDosError /NAME:NTDLL /NODEFAULTLIB /NOLOGO /OUT:$@ BTI_RDCL.TMP

BTI_RDCL.TMP: BTI_RDCL.MAK
	CL.EXE /Brepro /c /Fo$@ /Gz /nologo /Tc<< /W4 /wd4100 /X /Zl
// Copyright (C) 2018-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

__declspec(dllexport)
long	NtQuerySystemInformation(long _1, void *_2, long _3, void *_4)
{ return 0; }

__declspec(dllexport)
long	RtlNtStatusToDosError(long _1)
{ return 0; }
<<NOKEEP

BTI_RDCL.EXE: BTI_RDCL.RES BTI_RDCL.OBJ BTI_RDCL.LIB BTI_RDCL.DOS
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:KERNEL32.LIB /DEFAULTLIB:USER32.LIB /DYNAMICBASE /ENTRY:wWinMainCRTStartup /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OPT:REF /OSVERSION:5.0 /OUT:$@ /RELEASE /STUB:BTI_RDCL.DOS /SUBSYSTEM:WINDOWS /SWAPRUN:CD,NET /VERSION:1.0 BTI_RDCL.OBJ BTI_RDCL.RES BTI_RDCL.LIB

BTI_RDCL.OBJ: BTI_RDCL.MAK
	CL.EXE /Brepro /c /Fo$@ /GA /GF /GS /Gw /Gy /nologo /O1 /Oi /Os /Tc<< /W4 /wd4214 /we4013 /Zl
// Copyright (C) 2018-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)
#pragma comment(user, __TIMESTAMP__)

#define STRICT
#define UNICODE
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

extern	const	IMAGE_DOS_HEADER	__ImageBase;

// https://msdn.microsoft.com/en-us/library/cc231200.aspx
// https://msdn.microsoft.com/en-us/library/cc704588.aspx

typedef	enum	_NTSTATUS
{
	STATUS_SUCCESS              = 0x00000000,
	STATUS_UNSUCCESSFUL         = 0xC0000001,
	STATUS_NOT_IMPLEMENTED      = 0xC0000002,
	STATUS_INVALID_INFO_CLASS   = 0xC0000003,
	STATUS_INFO_LENGTH_MISMATCH = 0xC0000004
} NTSTATUS;

// https://msdn.microsoft.com/en-us/library/ms680600.aspx

__declspec(dllimport)
DWORD	NTAPI	RtlNtStatusToDosError(NTSTATUS Status);

typedef	enum	_SYSTEM_INFORMATION_CLASS
{
	SystemKernelVaShadowInformation     = 196,
	SystemSpeculationControlInformation = 201
} SYSTEM_INFORMATION_CLASS;

// https://msdn.microsoft.com/en-us/library/ms724509.aspx

__declspec(dllimport)
NTSTATUS	NTAPI	NtQuerySystemInformation(SYSTEM_INFORMATION_CLASS SystemInformationClass,
			                         LPVOID                   SystemInformation,
			                         DWORD                    SystemInformationLength,
			                         LPDWORD                  ReturnLength);

// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

__declspec(noreturn)
__declspec(safebuffers)
VOID	CDECL	wWinMainCRTStartup(VOID)
{
	NTSTATUS	ntStatus = STATUS_SUCCESS;

	// https://msdn.microsoft.com/en-us/library/ms724509.aspx

	struct
	{
		DWORD	KvaShadowEnabled : 1;			// Kernel Virtual Address Shadowing enabled
		DWORD	KvaShadowUserGlobal : 1;		// Kernel Virtual Address Shadowing enabled on user pages marked global
		DWORD	KvaShadowPcid : 1;			// PCID support (Westmere and later)
		DWORD	KvaShadowInvpcid : 1;			// INVPCID support (Haswell and later)
		DWORD	KvaShadowRequired : 1;
		DWORD	KvaShadowRequiredAvailable : 1;
		DWORD	InvalidPteBit : 6;
		DWORD	L1DataCacheFlushSupported : 1;
		DWORD	L1TerminalFaultMitigationPresent : 1;
		DWORD	Reserved : 18;
	} KvaShadowFlags;

	struct
	{
		DWORD	BpbEnabled : 1;				// Branch target injection protection enabled
		DWORD	BpbDisabledSystemPolicy : 1;		// PolicyOverride/PolicyOverrideMask registry setting
		DWORD	BpbDisabledNoHardwareSupport : 1;	// Microcode update not installed
		DWORD	SpecCtrlEnumerated : 1;			// IA32_SPEC_CTRL MSR support
		DWORD	SpecCmdEnumerated : 1;			// IA32_PRED_CMD MSR support (IBPB)
		DWORD	IbrsPresent : 1;			// IBRS support (Indirect Branch Restricted Speculation)
		DWORD	StibpPresent : 1;			// STIPB support (Single Thread Indirect Branch Predictors)
		DWORD	SmepPresent : 1;			// SMEP support (Supervisor-Mode Execution Prevention)
		DWORD	SpeculativeStoreBypassDisableAvailable : 1;
		DWORD	SpeculativeStoreBypassDisableSupported : 1;
		DWORD	SpeculativeStoreBypassDisabledSystemWide : 1;
		DWORD	SpeculativeStoreBypassDisabledKernel : 1;
		DWORD	SpeculativeStoreBypassDisableRequired : 1;
		DWORD	BpbDisabledKernelToUser : 1;
		DWORD	SpecCtrlRetpolineEnabled : 1;
		DWORD	SpecCtrlImportOptimizationEnabled : 1;
		DWORD	EnhancedIbrs : 1;
		DWORD	HvL1tfStatusAvailable : 1;
		DWORD	HvL1tfProcessorNotAffected : 1;
		DWORD	HvL1tfMigitationEnabled : 1;
		DWORD	HvL1tfMigitationNotEnabled_Hardware : 1;
		DWORD	HvL1tfMigitationNotEnabled_LoadOption : 1;
		DWORD	HvL1tfMigitationNotEnabled_CoreScheduler : 1;
		DWORD	EnhancedIbrsReported : 1;
		DWORD	MdsHardwareProtected : 1;
		DWORD	MbClearEnabled : 1;
		DWORD	MbClearReported : 1;
		DWORD	Reserved : 5;
	} SpeculationControlFlags;

	DWORD	dwError = ERROR_SUCCESS;

	INT	niBuffer = 0;
	WCHAR	szBuffer[1024];

	// https://msdn.microsoft.com/en-us/library/ms645402.aspx
	// https://msdn.microsoft.com/en-us/library/ms648029.aspx
	// https://msdn.microsoft.com/en-us/library/dd373908.aspx

	// BUG: if MB_DEFAULT_DESKTOP_ONLY is set, MessageBoxIndirect()
	//      displays no icon and fails with access violation when
	//      caption or text are specified as resources!

	MSGBOXPARAMS	mbp = {sizeof(mbp),
			       HWND_DESKTOP,
			       (HINSTANCE) &__ImageBase,
			       NULL,
			       L"\'Meltdown\' (CVE-2017-5754 [Rogue Data Cache Load])",
			       MB_USERICON | MB_OK,
			       MAKEINTRESOURCE(1),
			       (DWORD_PTR) NULL,
			       (MSGBOXCALLBACK) NULL,
			       MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT)};

	// https://msdn.microsoft.com/en-us/library/ms724509.aspx

	if ((ntStatus = NtQuerySystemInformation(SystemKernelVaShadowInformation,
	                                         &KvaShadowFlags,
	                                         sizeof(KvaShadowFlags),
	                                         (LPDWORD) NULL)) < 0)

		// https://msdn.microsoft.com/en-us/library/ms647550.aspx

		niBuffer = wsprintf(szBuffer, L"NtQuerySystemInformation(SystemKernelVaShadowInformation) returned status 0x%08lX\n"
		                              L"\n"
		                              L"Summary information:\n"
		                              L"\tMitigation for \'Meltdown\' (CVE-2017-5754 [Rogue Data Cache Load]) is not installed!\n"
		                              L"\n"
		                              L"Notes:\t0xC0000002 (STATUS_NOT_IMPLEMENTED) indicates that security update KB405689x is installed, but does not support this information request!\n"
		                              L"\t0xC0000003 (STATUS_INVALID_INFO_CLASS) indicates that security update KB405689x is not installed!\n",
		                    ntStatus);
	else
		// https://msdn.microsoft.com/en-us/library/ms647550.aspx

		niBuffer = wsprintf(szBuffer, L"NtQuerySystemInformation(SystemKernelVaShadowInformation) returned status 0x%08lX\n"
		                              L"\n"
		                              L"Summary information:\n"
		                              L"\tMitigation for \'Meltdown\' (CVE-2017-5754 [Rogue Data Cache Load]) is%ls enabled!\n"
		                              L"\n"
		                              L"Detail information:\n"
		                              L"\tKvaShadowFlags = 0x%08lX\n"
		                              L"\t%lc\tKvaShadowEnabled\n"
		                              L"\t\t(Mitigation enabled by Windows)\n"
		                              L"\t%lc\tKvaShadowUserGlobal\n"
		                              L"\t%lc\tKvaShadowPcid\n"
		                              L"\t\t(Processor supports PCID feature)\n"
		                              L"\t%lc\tKvaShadowInvpcid\n"
		                              L"\t\t(Processor supports INVPCID instruction)\n"
		                              L"\t%lc\tKvaShadowRequired\n"
		                              L"\t%lc\tKvaShadowRequiredAvailable\n"
		                              L"\t%lc\tL1DataCacheFlushSupported\n"
		                              L"\t%lc\tL1TerminalFaultMitigationPresent\n",
		                    ntStatus,
		                    KvaShadowFlags.KvaShadowEnabled ? L"" : L" not",
		                    *(LPDWORD) &KvaShadowFlags,
		                    L'0' + KvaShadowFlags.KvaShadowEnabled,
		                    L'0' + KvaShadowFlags.KvaShadowUserGlobal,
		                    L'0' + KvaShadowFlags.KvaShadowPcid,
		                    L'0' + KvaShadowFlags.KvaShadowInvpcid,
		                    L'0' + KvaShadowFlags.KvaShadowRequired,
		                    L'0' + KvaShadowFlags.KvaShadowRequiredAvailable,
		                    L'0' + KvaShadowFlags.L1DataCacheFlushSupported,
		                    L'0' + KvaShadowFlags.L1TerminalFaultMitigationPresent);

	if (niBuffer != 0)
	{
		szBuffer[niBuffer] = L'\0';

		mbp.lpszText = szBuffer;
	//	mbp.lpszCaption = L"\'Meltdown\' (CVE-2017-5754 [Rogue Data Cache Load])";
	//	mbp.lpszIcon = MAKEINTRESOURCE(1);

		// https://msdn.microsoft.com/en-us/library/ms645511.aspx

		if (MessageBoxIndirect(&mbp) == 0)
			dwError = GetLastError();
		else
			// https://msdn.microsoft.com/en-us/library/ms680600.aspx

			dwError = RtlNtStatusToDosError(ntStatus);
	}
	else	// https://msdn.microsoft.com/en-us/library/ms679360.aspx

		dwError = GetLastError();

	// https://msdn.microsoft.com/en-us/library/ms724509.aspx

	if ((ntStatus = NtQuerySystemInformation(SystemSpeculationControlInformation,
	                                         &SpeculationControlFlags,
	                                         sizeof(SpeculationControlFlags),
	                                         (LPDWORD) NULL)) < 0)

		// https://msdn.microsoft.com/en-us/library/ms647550.aspx

		niBuffer = wsprintf(szBuffer, L"NtQuerySystemInformation(SystemSpeculationControlInformation) returned status 0x%08lX\n"
		                              L"\n"
		                              L"Summary information:\n"
		                              L"\tMitigation for \'Spectre\' (CVE-2017-5715 [Branch Target Injection], CVE-2017-5753 [Bounds Check Bypass]) and \'Spectre-NG\' (CVE-2018-3639 [Speculative Store Bypass], CVE-2018-3640 [Rogue System Register Read]) is not installed!\n"
		                              L"\n"
		                              L"Notes:\t0xC0000002 (STATUS_NOT_IMPLEMENTED) indicates that security update KB405689x is installed, but does not support this information request!\n"
		                              L"\t0xC0000003 (STATUS_INVALID_INFO_CLASS) indicates that security update KB405689x is not installed!\n",
		                    ntStatus);
	else
		// https://msdn.microsoft.com/en-us/library/ms647550.aspx

		niBuffer = wsprintf(szBuffer, L"NtQuerySystemInformation(SystemSpeculationControlInformation) returned status 0x%08lX\n"
		                              L"\n"
		                              L"Summary information:\n"
		                              L"\tMitigation for \'Variant 2\' (CVE-2017-5715 [Branch Target Injection]) is%ls enabled!\n"
		                              L"\tMitigation for \'Variant 4\' (CVE-2018-3639 [Speculative Store Bypass]) is%ls enabled!\n"
		                              L"\n"
		                              L"Detail information:\n"
		                              L"\tSpeculationControlFlags = 0x%08lX\n"
		                              L"\t%lc\tBpbEnabled\n"
		                              L"\t\t(Mitigation enabled by Windows)\n"
		                              L"\t%lc\tBpbDisabledSystemPolicy\n"
		                              L"\t\t(Mitigation disabled via Registry)\n"
		                              L"\t%lc\tBpbDisabledNoHardwareSupport\n"
		                              L"\t\t(Microcode update missing)\n"
		                              L"\t%lc\tSpecCtrlEnumerated\n"
		                              L"\t\t(Processor supports IA32_SPEC_CTRL MSR)\n"
		                              L"\t%lc\tSpecCmdEnumerated\n"
		                              L"\t\t(Processor supports IA32_SPEC_CMD MSR)\n"
		                              L"\t%lc\tIbrsPresent\n"
		                              L"\t\t(Processor supports IBRS feature)\n"
		                              L"\t%lc\tStibpPresent\n"
		                              L"\t\t(Processor supports STIBP feature)\n"
		                              L"\t%lc\tSmepPresent\n"
		                              L"\t\t(Processor supports SMEP feature)\n"
		                              L"\t%lc\tSsbdAvailable\n"
		                              L"\t%lc\tSsbdSupported\n"
		                              L"\t%lc\tSsbdSystemWide\n"
		                              L"\t%lc\tSsbdKernel\n"
		                              L"\t%lc\tSsbdRequired\n"
		                              L"\t%lc\tBpbDisabledKernelToUser\n"
		                              L"\t%lc\tSpecCtrlRetpolineEnabled\n"
		                              L"\t%lc\tSpecCtrlImportOptimizationEnabled\n",
		                    ntStatus,
		                    SpeculationControlFlags.BpbEnabled ? L"" : L" not",
		                    SpeculationControlFlags.SpeculativeStoreBypassDisabledSystemWide ? L"" : L" not",
		                    *(LPDWORD) &SpeculationControlFlags,
		                    L'0' + SpeculationControlFlags.BpbEnabled,
		                    L'0' + SpeculationControlFlags.BpbDisabledSystemPolicy,
		                    L'0' + SpeculationControlFlags.BpbDisabledNoHardwareSupport,
		                    L'0' + SpeculationControlFlags.SpecCtrlEnumerated,
		                    L'0' + SpeculationControlFlags.SpecCmdEnumerated,
		                    L'0' + SpeculationControlFlags.IbrsPresent,
		                    L'0' + SpeculationControlFlags.StibpPresent,
		                    L'0' + SpeculationControlFlags.SmepPresent,
		                    L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisableAvailable,
		                    L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisableSupported,
		                    L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisabledSystemWide,
		                    L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisabledKernel,
		                    L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisableRequired,
		                    L'0' + SpeculationControlFlags.BpbDisabledKernelToUser,
		                    L'0' + SpeculationControlFlags.SpecCtrlRetpolineEnabled,
		                    L'0' + SpeculationControlFlags.SpecCtrlImportOptimizationEnabled);

	if (niBuffer != 0)
	{
		szBuffer[niBuffer] = L'\0';

	//	mbp.lpszText = szBuffer;
		mbp.lpszCaption = L"\'Spectre\' (CVE-2017-5715, CVE-2017-5753, CVE-2018-3639 & CVE-2018-3640)";
		mbp.lpszIcon = MAKEINTRESOURCE(2);

		// https://msdn.microsoft.com/en-us/library/ms645511.aspx

		if (MessageBoxIndirect(&mbp) == 0)
			dwError = GetLastError();
		else
			// https://msdn.microsoft.com/en-us/library/ms680600.aspx

			dwError = RtlNtStatusToDosError(ntStatus);
	}
	else	// https://msdn.microsoft.com/en-us/library/ms679360.aspx

		dwError = GetLastError();

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(dwError);
}
<<NOKEEP

BTI_RDCL.RES: BTI_RDCL.MAK MELTDOWN.ICO SPECTRE.ICO
	RC.EXE /DUNICODE /Fo$@ /L 0 /N /R /V <<
// Copyright (C) 2018-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

#define STRICT

#include <winnt.h>
#include <winuser.h>
#include <winver.h>

LANGUAGE LANG_NEUTRAL, SUBLANG_NEUTRAL

1 ICON "MELTDOWN.ICO"	// https://meltdownattack.com/favicon.ico
2 ICON "SPECTRE.ICO"	// https://spectreattack.com/favicon.ico

// https://msdn.microsoft.com/en-us/library/dn481241.aspx
// https://msdn.microsoft.com/en-us/library/dd371711.aspx

CREATEPROCESS_MANIFEST_RESOURCE_ID RT_MANIFEST
BEGIN
#ifdef UTF8BOM
    // https://msdn.microsoft.com/en-us/library/dd374101.aspx

    "\xEF\xBB\xBF"
#endif
    // BUG: the module loader fails with STATUS_SXS_CANT_GEN_ACTCTX
    //      when a valid encoding other than 'UTF-8' is specified!
#ifdef UTF8XML
    "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>\n"
#endif
    "<!-- Copyright (C) 2018-2024, Stefan Kanthak -->\n"
    "<assembly manifestVersion='1.0' xmlns='urn:schemas-microsoft-com:asm.v1'>\n"
    "    <assemblyIdentity name='eSKamation.Utility.Meltdown_Spectre' processorArchitecture='*' type='win32' version='1.0.2.0' />\n"
    "    <compatibility xmlns='urn:schemas-microsoft-com:compatibility.v1'>\n"
    "        <application>\n"
    "            <supportedOS Id='{e2011457-1546-43c5-a5fe-008deee3d3f0}' />\n" // NT 6.0
    "            <supportedOS Id='{35138b9a-5d96-4fbd-8e2d-a2440225f93a}' />\n" // NT 6.1
    "            <supportedOS Id='{4a2f28e3-53b9-4441-ba9c-d69d4a4a6e38}' />\n" // NT 6.2
    "            <supportedOS Id='{1f676c76-80e1-4239-95bb-83d0f6d0da78}' />\n" // NT 6.3
    "            <supportedOS Id='{8e0f7a12-bfb3-4fe8-b9a5-48fd50a15a9a}' />\n" // NT 10
    "        </application>\n"
    "    </compatibility>\n"
    "    <description>Meltdown, Spectre and Spectre-NG Update Check Utility</description>\n"
#if 0
    "    <trustInfo xmlns='urn:schemas-microsoft-com:asm.v2'>\n"
    "        <security>\n"
    "            <requestedPrivileges>\n"
    "                <requestedExecutionLevel level='asInvoker' uiAccess='false' />\n"
    "            </requestedPrivileges>\n"
    "        </security>\n"
    "    </trustInfo>\n"
#endif
    "</assembly>\n"
END

VERSION 0x20240107UL

// https://msdn.microsoft.com/en-us/library/aa381058.aspx
// https://msdn.microsoft.com/en-us/library/aa381049.aspx
// https://msdn.microsoft.com/en-us/library/aa381057.aspx

VS_VERSION_INFO VERSIONINFO
FILEFLAGS       VS_FF_PRIVATEBUILD | VS_FF_SPECIALBUILD
FILEFLAGSMASK   VS_FFI_FILEFLAGSMASK
FILEOS          VOS_NT_WINDOWS32
FILETYPE        VFT_APP
FILESUBTYPE     VFT2_UNKNOWN
FILEVERSION     1,0,2,0
PRODUCTVERSION  1,0,2,0
BEGIN
    BLOCK "StringFileInfo"
    BEGIN
#ifdef UNICODE
        BLOCK "040904B0"
#else
        BLOCK "040904E4"
#endif
        BEGIN
            VALUE "Comments",         "https://skanthak.hier-im-netz.de/spectre.html"
            VALUE "CompanyName",      "eSKamation"
            VALUE "FileDescription",  "Meltdown (CVE-2017-5754 [Rogue Data Cache Load]), Spectre (CVE-2017-5715 [Branch Target Injection], CVE-2017-5753 [Bounds Check Bypass]) and Spectre-NG (CVE-2018-3639 [Speculative Store Bypass], CVE-2018-3639 [Rogue System Register Read]) Update Check Utility"
            VALUE "FileVersion",      "1.0.2.0"
            VALUE "InternalName",     "BTI_RDCL"
            VALUE "LegalCopyright",   "Copyright  2018-2024, Stefan Kanthak"
        //  VALUE "LegalTrademarks",  ""
        //  VALUE "OLESelfRegister",  "Disabled"
            VALUE "OriginalFilename", "BTI_RDCL.EXE"
            VALUE "PrivateBuild",     "NOMSVCRT"
            VALUE "ProductName",      "Meltdown, Spectre and Spectre-NG Update Check Utility"
            VALUE "ProductVersion",   "1.0.2.0"
            VALUE "SpecialBuild",     "Release"
        END
    END
    BLOCK "VarFileInfo"
    BEGIN
#ifdef UNICODE
        VALUE "Translation", 0x0409, 1200
#else
        VALUE "Translation", 0x0409, 1252
#endif
    END
END
<<NOKEEP

BTI_RDCL.DOS: BTI_RDCL.MAK
	CERTUTIL.EXE /DecodeHex /F /V << $@
4D 5A 90 00 01 00 00 00 04 00 00 00 FF FF 00 00  MZ..............
D8 00 00 00 43 00 00 00 40 00 00 00 00 00 00 00  ....C...@.......
00 00 00 00 19 57 04 27 00 00 00 00 00 00 00 00  .....W.'........
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................
28 43 29 6F 70 79 72 69 67 68 74 20 32 30 30 34  (C)opyright 2004
2D 32 30 32 34 2C 20 53 74 65 66 61 6E 20 4B 61  -2024, Stefan Ka
6E 74 68 61 6B 20 3C 73 74 65 66 61 6E 2E 6B 61  nthak <stefan.ka
6E 74 68 61 6B 40 6E 65 78 67 6F 2E 64 65 3E 0D  nthak@nexgo.de>.
0A 07 24 0E 1F 33 D2 B4 09 CD 21 B8 01 4C CD 21  .....3....!..L.!
<<NOKEEP
